package gruppe27;


import junit.framework.TestCase;

import java.util.Collection;


public class FahrzielListeTest extends TestCase {

    private FahrzielListe fahrzielListe;

    protected void setUp() throws Exception {
        fahrzielListe = new FahrzielListe();
    }

    public void testInitialeListeIstLeer() throws Exception {
        assertTrue(fahrzielListe.istLeer());
    }

    public void testFahrzielHinzufgen() throws Exception {
        fahrzielListe.fgeHinzu(new Ebene(0));
        assertFalse(fahrzielListe.istLeer());
        assertEquals(1, fahrzielListe.gibAnzahlFahrziele());
        fahrzielListe.fgeHinzu(new Ebene(1));
        assertEquals(2, fahrzielListe.gibAnzahlFahrziele());
    }

    public void testGleichesFahrzielMehrfachAnfordern() throws Exception {
        fahrzielListe.fgeHinzu(new Ebene(0));
        fahrzielListe.fgeHinzu(new Ebene(0));
        assertEquals(1, fahrzielListe.gibAnzahlFahrziele());
    }

    public void testStatusFrEbene() throws Exception {
        final Ebene ebene0 = new Ebene(0);
        Status statusVorher = fahrzielListe.gibStatus(ebene0);
        assertFalse(statusVorher.istEbeneAngefordert());
        fahrzielListe.fgeHinzu(ebene0);
        Status statusNachher = fahrzielListe.gibStatus(ebene0);
        assertTrue(statusNachher.istEbeneAngefordert());
    }

    public void testEntferneEbene() throws Exception {
        Ebene ebene0 = new Ebene(0);
        fahrzielListe.fgeHinzu(ebene0);
        fahrzielListe.fgeHinzu(new Ebene(1));
        fahrzielListe.entferne(ebene0);
        assertEquals(1, fahrzielListe.gibAnzahlFahrziele());
    }

    public void testGesamtStatus() throws Exception {
        Ebene ebene0 = new Ebene(0);
        fahrzielListe.fgeHinzu(ebene0);
        Ebene ebene1 = new Ebene(1);
        fahrzielListe.fgeHinzu(ebene1);
        Collection fahrziele = fahrzielListe.gibFahrziele();
        assertEquals(2, fahrziele.size());
        assertTrue(fahrziele.contains(ebene0));
        assertTrue(fahrziele.contains(ebene1));
    }

    public void testUnvernderbarerGesamtStatus() throws Exception {
        Ebene ebene0 = new Ebene(0);
        fahrzielListe.fgeHinzu(ebene0);
        Collection fahrziele = fahrzielListe.gibFahrziele();
        try {
            fahrziele.remove(ebene0);
            fail();
        } catch (UnsupportedOperationException e) {
        }
    }

}
